#include	"bart.h"
#include	"moe.h"

char	*bart_map[33];

//---------------------------------------------------------------------------
void	bart_initmap()
{
    int i,x,y;
    float d,X,Y;
    int c;

    for(i=2;i<33;++i)
    {
	bart_map[i] = (char *)malloc(i*i*4);
	
	for(x=0;x<i*2;++x)
	for(y=0;y<i*2;++y)
	{
	    X=(x-i)/(float)i;
     	    Y=(y-i)/(float)i;

	    d=sqrt(X*X + Y*Y);

	    d*=256;

	    if(d>255 || d<0) d=255;

	    c=255-d;
	    //c=(c<<16)+(c<<8)+c;

	    bart_map[i][x+(y*i*2)]=(char)c;
	}
    }
    bart_map[0]=bart_map[2];
    bart_map[1]=bart_map[2];
}
//---------------------------------------------------------------------------
void	bart_draw(int *buffy,BART b)
{
    int x,y,color,_x,_y,pos;
    char _r,_v,_b;
    int rad=b.radius, diam;
    int R=b.r, V=b.v, B=b.b;
    int X=b.x, Y=b.y, Z=b.z;

    _asm {
	mov	eax,rad
	shl	eax,1
	mov	diam,eax 	//diam=(rad<<1);
    };
	/*if(!Z)Z=1;
	X = (X*320/Z)+160;
	Y = (Y*200/Z)+100;*/

    for(x=0; x<diam; ++x)
    for(y=0; y<diam; ++y)
    {
	_asm {
	    mov		eax,y
	    mul		diam
	    mov		_y,eax 		//_y = y*diam;
	};
	    
	_r = (bart_map[rad][x+_y] * R)>>8;
	_v = (bart_map[rad][x+_y] * V)>>8;
	_b = (bart_map[rad][x+_y] * B)>>8;

	_x = x+X-rad;
	_y = y+Y-rad;
	
	if(_x>0 && _x<320 && _y>0 && _y<200)
        {
	    //pos = _x+(_y<<8)+(_y<<6);
	    _asm {
		mov	eax,_y
		mov	ebx,eax
		shl	eax,8
		shl	ebx,6
		add	ebx,eax
		add	ebx,_x
		shl	ebx,2		// GAAARGHL !!! 1 int = 4 bytes !!!
		mov	pos,ebx 	//color = buffy[pos];
		add	ebx,buffy
		mov	eax,[ebx]
		mov	color,eax	//color = buffy[pos];
		and	eax,0xFF0000
		shr	eax,16
		xor	bx,bx
		mov	bl,_r
		add	ax,bx
		or	ah,ah
		jz	suite1
		mov	al,255
	suite1:
		mov	_r,al 		//_r = Top255(GetR(color)+_r);

		mov	eax,color
		and	eax,0xFF00
		shr	eax,8
		mov	bl,_v
		add	ax,bx
		or	ah,ah
		jz	suite2
		mov	al,255
	suite2:
		mov	_v,al 		//_v = Top255(GetV(color)+_v);

		mov	eax,color
		and	eax,0xFF
		mov	bl,_b
		add	ax,bx
		or	ah,ah
		jz	suite3
		mov	al,255
	suite3:
		mov	_b,al		//_b = Top255(GetB(color)+_b);

		mov	ebx,pos
		add	ebx,buffy
		mov	al,_r
		shl	eax,16
		mov	ah,_v
		mov	al,_b
		mov	[ebx],eax 	//buffy[pos] = (_r<<16) + (_v<<8) + _b;
	    };
	}
    }
}
//---------------------------------------------------------------------------
void	bart_new(BART *list,BART b)
{
    int i;

    for(i=0;i<N_BART;++i)
    {
	if(list[i].power<=0)
	{
	    list[i]=b;
	    return;
	}
    }
    
}
//---------------------------------------------------------------------------
void	bart_freelist(BART *list)
{
    free(list);
}
//---------------------------------------------------------------------------
void	bart_drawall(int *buffy,BART *list)
{
    int i;

    for(i=0;i<N_BART;++i)
    {
	if(list[i].power>0)
	{
	    bart_draw(buffy,list[i]);
	}
    }
}
//---------------------------------------------------------------------------
void	bart_freemap()
{
    int i;
    for(i=0;i<33;++i)
    {
	free(bart_map[i]);
    }
}
//---------------------------------------------------------------------------
