#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<math.h>
#include	"moe.h"
#include	"midasdll.h"
#include	"filters.h"
#include	"rotozoom.h"
#include	"tunseq.h"

void radial_blur_init();
void radial_blur_effect();

MIDASmodule module;
MIDASmodulePlayHandle playhandle;

int *scroll;
int *title;

int fc, lastfc;		// frame count and last frame count
int elapsed_time;	// elapsed time since last draw

/* info sur le midas - updated par UpdateInfo */
unsigned	position;
unsigned	pattern;
unsigned	row;
int		syncinfo;

/* affiche la derniere erreur MIDAS et exit sous DOS */
void midaserror(void)
{
    setmode(3);
    printf("MIDAS error: %s\n", MIDASgetErrorMessage(MIDASgetLastError()));
    MIDASclose();
    exit(EXIT_FAILURE);
}

void MIDAS_CALL updateinfo(void)
{
    static MIDASplayStatus status;

    if (!MIDASgetPlayStatus(playhandle, &status)) midaserror();

    position	= status.position;
    pattern	= status.pattern;
    row		= status.row;
    syncinfo	= status.syncInfo;
}

void MIDAS_CALL timercall()
{
    ticks++;
}

void scroll_effect()
{
    int y=0;
    int count;

    scroll=(int *)malloc(320*1068*4);
    loadraw(scroll, "SCROLL.RAW", 320*1068*3);

    do
    {
	count = ticks;
	if (y<710)
	{
	    y=count>>2;
	}
	else y=710;

	memcpy(screen, scroll+320*y, 320*200*4);
	blur_center_x=cos(count/100.0)*3.0 + 160;
	blur_center_y=cos(count/100.0)*12.0 + 100;
	radial_blur(screen);

//	waitvbl();
	while (count==ticks);
	MOEflip();
    } while (!(inp(0x60)==1) && (count<35*sec));
}

void title_effect()
{
    int old_pattern;
    int count;
    int h;
    updateinfo();

    END=0;

    old_pattern=pattern;
    while ((!END) && (pattern==old_pattern))
    {
	count = ticks;
	updateinfo();
 	if (count<3*sec) h = 31- count*31/(3*sec);
	if (h>0) hblur(screen, title, h, 0, 200);

	while (count==ticks);
	MOEflip();
	if (inp(0x60)==1) END=1;
    }
}

void title_init()
{
    title=(int *)malloc(320*200*4);
    loadraw(title, "TITRE.RAW", 320*200*3);
}

void main(/*int argc, char *argv[]*/)
{
    int i,j;
    
    /* midas init */
/*    argc=argc;
    argv=argv;
*/
    MIDASstartup();

  /*  if ( (argc>1) || (!MIDASdetectSoundCard()) )
    {
	if (!MIDASconfig())
	{
	    /* fuck le menu de config a foire */
/*	    if (MIDASgetLastError() )
	    {
		midaserror();
	    }
	    else
	    {
		printf("User exit!\n");
		exit;
	    }
	}
    }
*/
    if (!MIDASinit()) midaserror();

    puts("Loading musik...");
    if ( (module=MIDASloadModule("BLAST.XM"))==NULL )
    	midaserror();

    hblur_init();
    title_init();
    stars_init();
    seq1init();
    radial_blur_init();

//    MOEvmode=0;
    MOEinit();

    /* yeepee play da zicmu */
    if ((playhandle = MIDASplayModule(module, FALSE)) == 0) midaserror();
    if (!MIDASsetTimerCallbacks(140000, FALSE, &timercall, NULL, NULL)) midaserror();

    title_effect();
    tunnel(0, 7*sec+35);
    radial_blur_effect(0, 7*sec+35);
    tunnel(1, 7*sec+35);
    radial_blur_effect(1, 7*sec+35);
    tunnel(2, 7*sec+35);
    radial_blur_effect(2, 7*sec+35);
    tunnel(3, 7*sec+35);
    radial_blur_effect(3, 7*sec+35);
    tunnel(4, 7*sec+35);
    radial_blur_effect(4, 7*sec+35);
    tunnel(5, 7*sec+35);
    radial_blur_effect(5, 7*sec+35);
    tunnel(6, 7*sec+35);
    radial_blur_effect(6, 7*sec+35);
    tunnel(7, 7*sec+35);
    radial_blur_effect(7, 7*sec+35);
//    tunnel(8, 7*sec+30);
//    radial_blur_effect(8, 7*sec+30);

    stars_effect();
    ticks=0;
    scroll_effect();


    vesa_free_info();
    _asm
    {
	mov ax, 3h
	int 10h
    }
    if (!MIDASstopModule(playhandle)) midaserror();
    if (!MIDASfreeModule(module))     midaserror();
    if (!MIDASremoveTimerCallbacks()) midaserror();
    if (!MIDASclose())                midaserror();
  
    printf("d'Oh supplied you with approximatively 2.3 effects\n");
}

