#include "moe.h"
#include "filters.h"

#define divfactor 2

int blur_center_x;
int blur_center_y;

int divprecalc[64*256*64];

void hblur(int *dest, int *source, int larg, int ymin, int ymax)
{
    int i;
    int RRBB;
    int GG;
    int xmin, xmax;
    int RGBIn;
    int x, y;
    int diviseur=2*larg+1;
    int *LUT;
    int *sourceleft, *sourceright;
    int sourceplus=320-larg;

    LUT= divprecalc + larg*64*256;
    source+=ymin*320;
    sourceleft=source-larg-1;
    sourceright=source+larg;
    dest+=ymin*320;
    
    for (y=ymin; y<ymax; y++)
    {
	RRBB=0; GG=0;
	for (i=0; i<larg; i++)
	{
	    RGBIn=*source++;
	    RRBB+=(RGBIn&0x00FF00FF);
	    GG+=(RGBIn&0x0000FF00);
	}
	
	for (x=0; x<larg+1; x++)
	{
	    RGBIn=*sourceright++;
	    RRBB+=RGBIn&0x00FF00FF;
	    GG+=RGBIn&0x0000FF00;

	    sourceleft++;

	    *dest++=
		(LUT[RRBB>>16]<<16)+
		(LUT[RRBB&0x0000FFFF])+
		(LUT[GG>>8]<<8);
	}
	
	for (x=larg+1; x<XMax-larg; x++)
	{
	    RGBIn=*sourceleft++;
	    RRBB-=RGBIn&0x00FF00FF;
	    GG-=RGBIn&0x0000FF00;
	    
	    RGBIn=*sourceright++;
	    RRBB+=RGBIn&0x00FF00FF;
	    GG+=RGBIn&0x0000FF00;

	    *dest++=
		(LUT[RRBB>>16]<<16)+
		(LUT[RRBB&0x0000FFFF])+
		(LUT[GG>>8]<<8);
	}
	
	for (x=XMax-larg; x<XMax; x++)
	{
	    RGBIn=*sourceleft++;
	    RRBB-=RGBIn&0x00FF00FF;
	    GG-=RGBIn&0x0000FF00;

	    sourceright++;

	    *dest++=
		(LUT[RRBB>>16]<<16)+
		(LUT[RRBB&0x0000FFFF])+
		(LUT[GG>>8]<<8);
	}

	source+=sourceplus;
    }
}

void hblur_init()
{
    int i, j;

    for (j=0; j<64*256; j++)
    	for (i=0; i<64; i++)
	    divprecalc[(i*64*256)+j]=j/(i*2+1);
}
    

void radial_blur_no_mmx(int *screen)
{
    int i, j;
    int x, y;
    int c1,c2;
    int r1, g1, b1;
    int r2, g2, b2;
    
    for (j=blur_center_y; j<200; j++)
    	for (i=blur_center_x; i<320; i++)
	{
	    {
		x=(blur_center_x-i)>>divfactor;
	    	y=(blur_center_y-j)>>divfactor;
	    	c1=screen[320*(j+y)+(i+x)];
	    }
    	    c2=screen[(j<<6)+(j<<8)+i];
	    r1=(c1&0xFF0000);	r2=(c2&0xFF0000);
	    g1=(c1&0x00FF00);	g2=(c2&0x00FF00);
	    b1=(c1&0x0000FF);	b2=(c2&0x0000FF);
	    r1=((r1+r2)>>1) &0xFF0000;
	    g1=((g1+g2)>>1) &0x00FF00;
	    b1=((b1+b2)>>1) &0x0000FF;
	    screen[(j<<6)+(j<<8)+i]=r1+g1+b1;
	}
    for (j=blur_center_y; j<200; j++)
    	for (i=blur_center_x-1; i>=0; i--)
	{
	    {
		x=(blur_center_x-i)>>divfactor;
	    	y=(blur_center_y-j)>>divfactor;
	    	c1=screen[320*(j+y)+(i+x)];
	    }
    	    c2=screen[(j<<6)+(j<<8)+i];
	    r1=(c1&0xFF0000);	r2=(c2&0xFF0000);
	    g1=(c1&0x00FF00);	g2=(c2&0x00FF00);
	    b1=(c1&0x0000FF);	b2=(c2&0x0000FF);
	    r1=((r1+r2)>>1) &0xFF0000;
	    g1=((g1+g2)>>1) &0x00FF00;
	    b1=((b1+b2)>>1) &0x0000FF;
	    screen[(j<<6)+(j<<8)+i]=r1+g1+b1;
	}
    for (j=blur_center_y-1; j>=0; j--)
    	for (i=blur_center_x; i<320; i++)
	{
	    {
		x=(blur_center_x-i)>>divfactor;
	    	y=(blur_center_y-j)>>divfactor;
	    	c1=screen[320*(j+y)+(i+x)];
	    }
    	    c2=screen[(j<<6)+(j<<8)+i];
	    r1=(c1&0xFF0000);	r2=(c2&0xFF0000);
	    g1=(c1&0x00FF00);	g2=(c2&0x00FF00);
	    b1=(c1&0x0000FF);	b2=(c2&0x0000FF);
	    r1=((r1+r2)>>1) &0xFF0000;
	    g1=((g1+g2)>>1) &0x00FF00;
	    b1=((b1+b2)>>1) &0x0000FF;
	    screen[(j<<6)+(j<<8)+i]=r1+g1+b1;
	}
    for (j=blur_center_y-1; j>=0; j--)
    	for (i=blur_center_x-1; i>=0; i--)
	{
	    {
		x=(blur_center_x-i)>>divfactor;
	    	y=(blur_center_y-j)>>divfactor;
	    	c1=screen[320*(j+y)+(i+x)];
	    }
    	    c2=screen[(j<<6)+(j<<8)+i];
	    r1=(c1&0xFF0000);	r2=(c2&0xFF0000);
	    g1=(c1&0x00FF00);	g2=(c2&0x00FF00);
	    b1=(c1&0x0000FF);	b2=(c2&0x0000FF);
	    r1=((r1+r2)>>1) &0xFF0000;
	    g1=((g1+g2)>>1) &0x00FF00;
	    b1=((b1+b2)>>1) &0x0000FF;
	    screen[(j<<6)+(j<<8)+i]=r1+g1+b1;
	}
}

int andmask[2]={0x7F7F7F, 0x7F7F7F};
void radial_blur_mmx(int *screen)
{
    int i, j;
    int x, y;
    int c1,c2;
    int r1, g1, b1;
    int r2, g2, b2;
    int *screen_temp;
    int *screen_dest;
    int *screen_source;

    _asm
    {
	movq mm2, andmask
    }
    
    for (j=blur_center_y; j<200; j++)
    {
	/*    |    */
	/* ---|--- */
	/*    | X  */

	y=(blur_center_y-j)>>divfactor;
	screen_dest = screen + j*320 + blur_center_x;
	screen_source = screen + (j+y)*320;
    	for (i=blur_center_x; i<320; i++)
	{
	    x=(blur_center_x-i)>>divfactor;
	    c1=screen_source[i+x];
    	    c2=*screen_dest;
	    _asm {
		movq mm0, [c1]
		movq mm1, [c2]
		psrld mm0, 1
		psrld mm1, 1
		pand mm0, mm2
		pand mm1, mm2
		paddb mm0, mm1
		movq [c1], mm0
	    };
	    *screen_dest++=c1;
	}

	/*    |    */
	/* ---|--- */
	/*  X |    */
	
	screen_dest = screen + j*320 + blur_center_x - 1;
    	for (i=blur_center_x-1; i>=0; i--)
	{
	    x=(blur_center_x-i)>>divfactor;
	    c1=screen_source[i+x];
    	    c2=*screen_dest;
	    _asm {
		movq mm0, [c1]
		movq mm1, [c2]
		psrld mm0, 1
		psrld mm1, 1
		pand mm0, mm2
		pand mm1, mm2
		paddb mm0, mm1
		movq [c1], mm0
	    };
	    *screen_dest--=c1;
	}
    }
    for (j=blur_center_y-1; j>=0; j--)
    {
	/*    | X  */
	/* ---|--- */
	/*    |    */
	
	screen_dest = screen + j*320 + blur_center_x;
	y=(blur_center_y-j)>>divfactor;
	screen_source = screen + (j+y)*320;
    	for (i=blur_center_x; i<320; i++)
	{
	    x=(blur_center_x-i)>>divfactor;
	    c1=screen_source[i+x];
    	    c2=*screen_dest;
	    _asm {
		movq mm0, [c1]
		movq mm1, [c2]
		psrld mm0, 1
		psrld mm1, 1
		pand mm0, mm2
		pand mm1, mm2
		paddb mm0, mm1
		movq [c1], mm0
	    };
	    *screen_dest++=c1;
	}
	
	/*  X |    */
	/* ---|--- */
	/*    |    */
	
	screen_dest = screen + j*320 + blur_center_x - 1;
    	for (i=blur_center_x-1; i>=0; i--)
	{
	    x=(blur_center_x-i)>>divfactor;
	    c1=screen_source[i+x];
    	    c2=*screen_dest;
	    _asm {
		movq mm0, [c1]
		movq mm1, [c2]
		psrld mm0, 1
		psrld mm1, 1
		pand mm0, mm2
		pand mm1, mm2
		paddb mm0, mm1
		movq [c1], mm0
	    };
	    *screen_dest--=c1;
	}
    }
    _asm
    {
	emms
    }
}

void radial_blur(int *screen)
{
    if (mmx) radial_blur_mmx(screen);
    	else radial_blur_no_mmx(screen);
}

/* mix 2 video buffers with the AND operator */
void and_filter(int *dest, int *source, int count)
{
    if (mmx) and_filter_mmx(dest, source, count);
    	else and_filter_no_mmx(dest,source, count);
}

/* non MMX flavour */
void and_filter_no_mmx(int *dest, int *source, int count);
#pragma aux and_filter_no_mmx=\
" pixel:			"\
"	mov al, byte ptr [edi]	"\
"	mov bl, byte ptr [esi]	"\
"	sub al, bl		"\
"	jnc no_overflow		"\
"	xor al, al		"\
" no_overflow:			"\
"	stosb			"\
"	inc	esi		"\
"	loop pixel		"\
parm [edi] [esi] [ecx]\
modify [esi edi ecx al bl];

/* the same with MMX flavour */
void and_filter_mmx(int *dest, int *source, int count);
#pragma aux and_filter_mmx=\
" shr ecx, 3			"\
" pixel:			"\
"	movq mm1, [esi]		"\
"	movq mm0, [edi]		"\
"	psubusb mm0, mm1	"\
"	movq [edi], mm0		"\
"	add esi, 8		"\
"	add edi, 8		"\
"	loop pixel		"\
" emms				"\
parm [edi] [esi] [ecx]\
modify [esi edi ecx al bl];

void negate_no_mmx(int *screen);
#pragma aux negate_no_mmx=\
"	mov	ecx, 64000	"\
"  @@loop1:			"\
"	mov	eax, [edi]	"\
"	neg	eax		"\
"	stosd			"\
"	loop @@loop1		"\
parm [edi]\
modify [edi eax ecx];

int negate_const[2]={0xFFFFFFFF, 0xFFFFFFFF};
void negate_mmx(int *screen);
#pragma aux negate_mmx=\
"	mov	ecx, 32000	"\
"	movq	mm2, negate_const"\
"  @@loop1:			"\
"	movq	mm0, [edi]	"\
"	movq	mm1, mm2	"\
"	psubb	mm1, mm0	"\
"	movq	[edi], mm1	"\
"	add	edi, 8		"\
"	loop @@loop1		"\
"  emms				"\
parm [edi]\
modify [edi ecx];

void negate(int *screen)
{
    if (mmx) negate_mmx(screen);
    	else negate_no_mmx(screen);
}


