#include	<i86.h>
#include        <stdio.h>
#include	<string.h>
#include	<stdlib.h>
#include	<dos.h>
#include	<mmintrin.h>
#include	"moe.h"

/* end of DEMO!! */
int	END = 0;

/* MMX INSTRUCTION SET */

int mmx=0;			// MMX : 1 sinon 0
				// update par mmx_available()


/* MATH */

int *intCOS4096, *intSIN4096;
int *intCOS, *intSIN;


/* TIMER */

#define PIT_FREQUENCY  0x1234DDL
#define frequency      140
#define counter        PIT_FREQUENCY/frequency

int framecount=0;       	// nb of frames since last second
int fps=0;			// total nb of frames displayed last second

volatile int BIOS_ticks=0;
volatile int second_ticks=0;
volatile int ticks=0;
volatile int second_flag=0;

#define	VESA_MODE_320x200x16b	0x10E
#define	VESA_MODE_320x200x32b	0x10F

int *screen;             	// main video buffer
int *screen_bis;		// conversion 32->x bpp

int MOEvmode = -1;		// mode video

typedef struct RealPointer
{
	short			Segment;	//The real mode segment (offset is 0).
	short			Selector;	//In protected mode, you need to chuck this dude into a segment register and use an offset 0.
} RealPointer;

typedef struct VesaInfo
{
	char		Signature[4];
	short		Version;
	short		OEMNameOffset;
	short		OEMNameSegment;			//Pointer to OEM name?
	char		Capabilities[4];
	short		SupportedModesOffset;
	short		SupportedModesSegment;		//Pointer to list of supported VESA and OEM modes (terminated with 0xffff).
	char		Reserved[238];
} VesaInfo;

typedef struct VesaModeData
{
	short		ModeAttributes;
	char		WindowAAttributes;
	char		WindowBAttributes;
	short		WindowGranularity;
	short		WindowSize;
	short		StartSegmentWindowA;
	short		StartSegmentWindowB;
	void		(*WindowPositioningFunction)(int page);
	short		BytesPerScanLine;

	//Remainder of this structure is optional for VESA modes in v1.0/1.1, needed for OEM modes.

	short		PixelWidth;
	short		PixelHeight;
	char		CharacterCellPixelWidth;
	char		CharacterCellPixelHeight;
	char		NumberOfMemoryPlanes;
	char		BitsPerPixel;
	char		NumberOfBanks;
	char		MemoryModelType;
	char		SizeOfBank;
	char		NumberOfImagePages;
	char		Reserved1;

	//VBE v1.2+

	char		RedMaskSize;
	char		RedFieldPosition;
	char		GreenMaskSize;
	char		GreenFieldPosition;
	char		BlueMaskSize;
	char		BlueFieldPosition;
	char		ReservedMaskSize;
	char		ReservedFieldPosition;
	char		DirectColourModeInfo;
	char		Reserved2[216];
} VesaModeData;

typedef struct RMREGS
{
	int		edi;
	int		esi;
	int		ebp;
	int		reserved;
	int		ebx;
	int		edx;
	int		ecx;
	int		eax;
	short		flags;
	short		es,ds,fs,gs,ip,cs,sp,ss;
} RMREGS;

VesaInfo	far	*vesa_info		= NULL;
VesaModeData	far	*vesa_mode_data		= NULL;
int			vesa_granularity;
int			vesa_page;
int			vesa_width;
int			vesa_height;
int			vesa_bits_per_pixel;

RealPointer				vesa_info_rp;
RealPointer				vesa_mode_data_rp;

static void far *allocate_dos_memory(RealPointer * rp,int bytes_to_allocate);


void MOEflip()
{
    switch(MOEvmode)
    {
	case 0 : /* 32 bpp */
		 flip(screen, 4);
		 break;
	case 1 : conv24(screen_bis, screen);
	         flip(screen_bis, 3);
		 break;
	case 2 : /* 16 bpp */
		 conv16(screen_bis, screen);
		 flip(screen_bis, 2);
		 break;
//	case 3 : flip15(screen); break;
	case 4 : conv8((void *)0xa0000, screen);
		 break;
//	case 5 : fliptext(screen); break;
    }
}

void MOEinit()
{
    char c;

    _asm
    {
	mov ax, 3
	int 10h
    }
    
    printf("M.O.E ^ My Orgasmic Engine ^ initialisation\n\n");
    
    mmx=mmx_available();
    if (mmx) printf("MMX Extention found!\n");
    	else printf("MMX Extention not found!\n");
    
    if (MOEvmode==-1) /* menu de selection */
    {
	printf("Now choose your video mode:\n");
	printf("     ---> 0 <---  320x200 (32 bit) Recommended If Available !!\n");
	printf("     **** 1 ****  320x200 (24 bit)\n");
	printf("     **** 2 ****  320x200 (16 bit) Slower!\n");
	printf("     **** 4 ****  320x200 (8 bit) Simple Mode 13h (If The Others Fail)\n");
	printf("Make Your Choice :\n");
    
	do {
	    c=getch();
	} while (c!='0' && c!='1' && c!='2' && c!='4' && c!=27);
	if (c==27) /* break */
	{
	    printf("\nUser break!\n");
	    exit;
	}
	MOEvmode=c-'0';
    }

    switch(MOEvmode)
    {
	case 0: init_vesa(VESA_MODE_320x200x32b); break;
	case 1: init_vesa(VESA_MODE_320x200x32b); break; // move 24bpp!?!?
	case 2: init_vesa(VESA_MODE_320x200x16b); break;
	case 4: init_13h(); break;
    }

    /* alloc main 32bpp buffer */
    if ((screen=(int *)malloc(XMax * YMax * 4))==NULL) exit;
    
    /* alloc secondary buffer (for conversion) */
    if ((screen_bis=(int *)malloc(XMax*YMax*3))==NULL) exit;
}

/****************************************************************************/
/* Get information about the VESA driver.					*/
/*										*/
/* Returns:									*/
/*	TRUE		-	VESA driver present.  vesa_info set to point to a	*/
/*					a structure containing capability info etc.	*/
/*	FALSE		-	No VESA driver.					*/
/*										*/
/****************************************************************************/

int vesa_get_info(void)
{
    union		REGS	regs;
    struct		SREGS	sregs;
    RMREGS	rmregs;
    int ok = 0;

    if((vesa_info = (VesaInfo far *)allocate_dos_memory(&vesa_info_rp,sizeof(VesaInfo))) != NULL)
    {
	memset(&rmregs,0,sizeof(rmregs));
	memset(&regs,0,sizeof(regs));
	memset(&sregs,0,sizeof(sregs));
	segread(&sregs);
	rmregs.eax = 0x4f00;
	rmregs.es = vesa_info_rp.Segment;
	rmregs.ds = vesa_info_rp.Segment;
	regs.x.eax = 0x300;
	regs.x.ebx = 0x10;
	regs.x.ecx = 0;
	sregs.es = FP_SEG(&rmregs);
	regs.x.edi = FP_OFF(&rmregs);
	int386x(0x31,&regs,&regs,&sregs);	//Get vesa info.

	if(rmregs.eax == 0x4f) ok=1;
    }
    return(ok);
}

/****************************************************************************/
/* Free the information allocated with vesa_get_info()						*/
/****************************************************************************/

void vesa_free_info(void)
{
	free_dos_memory(&vesa_info_rp);
}

/****************************************************************************/
/* Set VESA video mode.  You MUST have previously called vesa_get_info().	*/
/*																			*/
/* Inputs:																	*/
/*	vmode	-	The VESA mode that you want. e.g. 0x101 is 640x480 256		*/
/*				colours.													*/
/*																			*/
/* Returns:																	*/
/*	TRUE	-	The mode has been set.										*/
/*	FALSE	-	The mode has not been set, probably not supported.			*/
/*																			*/
/****************************************************************************/

int vesa_set_mode(short vmode)
{
	union	REGS	regs;
	int ok=0;

	memset(&regs,0,sizeof(regs));
	regs.w.ax = 0x4f02;
	regs.w.bx = vmode;
	int386(0x10,&regs,&regs);
	if(regs.w.ax == 0x004f)
	{
		vesa_get_mode_info(vmode);
		vesa_set_page(0);			//Probably not needed, but here for completeness.
		ok = 1;
	}
	return(ok);
}

/****************************************************************************/
/* Get VESA mode information.  Information is loaded into vesa_mode_data.	*/
/* vesa_get_info() must be called before calling this function.				*/
/* Should error check this really.											*/
/*																			*/
/* Inputs:																	*/
/*	vmode	-	The mode that you wish to get information about.			*/
/*																			*/
/* Returns:																	*/
/*	TRUE	-	vesa_mode_data points to a filled VesaModeData structure.	*/
/*	FALSE	-	vesa_mode_data probably invalid.  Mode probably not			*/
/*				supported.													*/
/*																			*/
/****************************************************************************/

int vesa_get_mode_info(short vmode)
{
	union	REGS	regs;
	struct	SREGS	sregs;
	RMREGS			rmregs;
	int ok=0;

	if((vesa_mode_data = (VesaModeData far *)allocate_dos_memory(&vesa_mode_data_rp,sizeof(VesaModeData))) != NULL)
	{
		memset(&rmregs,0,sizeof(rmregs));
		rmregs.es = vesa_mode_data_rp.Segment;
		rmregs.ds = vesa_mode_data_rp.Segment;
		rmregs.edi = 0;
		rmregs.eax = 0x4f01;
		rmregs.ecx = vmode;
		memset(&regs,0,sizeof(regs));
		memset(&sregs,0,sizeof(sregs));
		segread(&sregs);
		regs.x.eax = 0x300;
		regs.x.ebx = 0x10;
		regs.x.edi = (int)&rmregs;
		int386x(0x31,&regs,&regs,&sregs);
		if(regs.h.al == 0)
		{

			//cache a few important items in protected mode memory area.

			vesa_granularity	= vesa_mode_data->WindowGranularity;
			vesa_width			= vesa_mode_data->PixelWidth;
			vesa_height			= vesa_mode_data->PixelHeight;
			vesa_bits_per_pixel	= vesa_mode_data->BitsPerPixel;
			ok = 1;
		}
	}
	return(ok);
}

/****************************************************************************/
/* Free the info previously allocated with vesa_get_info()					*/
/****************************************************************************/

void vesa_free_mode_info(void)
{
	free_dos_memory(&vesa_mode_data_rp);
}

/****************************************************************************/
/* Set the current vesa screen page.										*/
/*																			*/
/* Inputs:																	*/
/*	vpage	-	Page number to set.											*/
/*																			*/
/****************************************************************************/

void vesa_set_page(int vpage)
{
	union	REGS	regs;

	vesa_page = vpage;
	regs.w.ax = 0x4f05;
	regs.w.bx = 0;
	regs.w.cx = 0;
	regs.w.dx = (short)(vpage == 0 ? 0 : (short)((vpage * 64) / vesa_granularity));
	int386(0x10,&regs,&regs);
	regs.w.ax = 0x4f05;
	regs.w.bx = 1;
	regs.w.cx = 0;
	regs.w.dx = (short)(vpage == 0 ? 0 : (short)((vpage * 64) / vesa_granularity));
	int386(0x10,&regs,&regs);
}

void init_13h()
{
    int r, g, b;
    
    _asm
    {
	mov ax, 13h
	int 10h
    }

    outp(0x3c8, 0);
    for (r=0; r<8; r++)
    	for (b=0; b<4; b++)
	    for (g=0; g<8; g++)
	    {
		outp(0x3c9, (b<<4)+8);
		outp(0x3c9, (g<<3)+4);
		outp(0x3c9, (r<<3)+4);
	    }
}

void memcpymmx(int *dest, int *source, int count);
/* count doit etre un multiple de 8 (2do:le modulo) */
#pragma aux memcpymmx=\
" shr ecx, 3		"\
" count_loop:		"\
" 	movq mm0, [esi] "\
"	movq [edi], mm0 "\
"	add esi, 8	"\
"	add edi, 8	"\
" dec ecx		"\
" jnz count_loop  	"\
" emms			"\
parm [edi] [esi] [ecx]\
modify [esi edi ecx];

void flip(int *source, int bpp)
{
    int	page	 = 0;
    int	scr_size = XMax * YMax * bpp;

    while(scr_size > 0)
    {
	vesa_set_page(page);
	switch(mmx)
	{
	    case 0: memcpy((void *)0xa0000, source,
	                   (scr_size > 65536 ? 65536 : scr_size)); break;
	    case 1: memcpymmx((void *)0xa0000, source,
	                   (scr_size > 65536 ? 65536 : scr_size)); break;
	}
	scr_size -= 65536;
	source = (void *)((int)source + 65536);
	page++;
    }
}

void conv16(int *dest, int *source);
#pragma aux conv16 =\
" mov ecx, 64000	"\
" boucle:		"\
"	mov eax, [esi]	"\
"	and eax, 00000000111110001111110011111000b"\
"	shr ah, 2	"\
"	shr ax, 3	"\
"	ror eax, 8	"\
"	add al, ah	"\
"	rol eax, 8	"\
"	stosw		"\
"	add esi, 4	"\
" dec ecx		"\
" jnz boucle		"\
parm	[edi] [esi]\
modify	[edi esi ecx eax];

void conv24(int *dest, int *source);
#pragma aux conv24 =\
" mov ecx, 63999	"\
" boucle:		"\
"	mov eax, [esi]	"\
"	mov [edi], eax	"\
"	add esi, 4	"\
"	add edi, 3	"\
" dec ecx		"\
" jnz boucle		"\
" stosw			"\
" stosb			"\
parm	[edi] [esi]\
modify	[edi esi ecx eax];

void conv8(int *dest, int *source);
#pragma aux conv8 =\
" mov ecx, 64000	"\
" boucle:		"\
"	mov eax, [esi]	"\
"	and eax, 00000000110000001110000011100000b"\
"	shl eax, 8	"\
"	shr ax, 13	"\
"	ror eax, 14	"\
"	shl ax, 6	"\
"	shr eax, 13	"\
"	stosb		"\
"	add esi, 4	"\
" dec ecx		"\
" jnz boucle		"\
parm	[edi] [esi]\
modify	[edi esi ecx eax];

int mmx_available();
#pragma aux mmx_available=\
" mov eax, 1		"\
" cpuid			"\
" and edx, 800000h	"\
" shr edx, 23		"\
modify [eax edx] value [edx];

/****************************************************************************/
/* Allocate a region of DOS memory.											*/
/****************************************************************************/

static void far *allocate_dos_memory(RealPointer * rp,int bytes_to_allocate)
{
	void	far	*ptr	= NULL;
	union	REGS		regs;

	bytes_to_allocate = ((bytes_to_allocate + 15) & 0xfffffff0);	//Round up to nearest paragraph.
	memset(&regs,0,sizeof(regs));
	regs.w.ax = 0x100;
	regs.w.bx = (short)(bytes_to_allocate >> 4);		//Allocate dos memory in pages, so convert bytes to pages.
	int386(0x31,&regs,&regs);
	if(regs.x.cflag == 0)
	{	//Everything OK.
		rp->Segment = regs.w.ax;
		rp->Selector = regs.w.dx;
		ptr = MK_FP(regs.w.dx,0);
	}
	return(ptr);
}

/****************************************************************************/
/* Free an area of DOS memory.												*/
/****************************************************************************/

static void free_dos_memory(RealPointer * rp)
{
	union	REGS		regs;

	regs.w.ax = 0x101;
	regs.w.dx = rp->Selector;
	int386(0x31,&regs,&regs);
}

void waitvbl()
{
    while (!(inp (0x3da) & 8)) {}
    while (inp (0x3da) & 8) {}
}

void init_vesa(int vesa_mode)
{
    if (vesa_get_info()==0) goto ciao;
    if (vesa_set_mode(vesa_mode)==0) goto ciao;
    return;

ciao:
    printf("VESA mode not found! %d\n",vesa_mode);
    exit;
}

int loadraw(int *screen, char *nom, int size)
{
    FILE *fp;
    char *temp;
    int ret=0;
    int i;

    if ((temp=(char *)malloc(size))==NULL) goto ciao;
    if ((fp=fopen(nom, "rb"))==NULL) goto ciao;
    fread(temp, 1, size, fp);

    for (i=0; i<size/3; i++)
        screen[i]=(temp[i*3]<<16)+(temp[i*3+1]<<8)+temp[i*3+2];
    
    fclose(fp);
    free(temp);
    ret=1;

ciao:
    return ret;
}



void (__interrupt __far *prev_int_1c)();

void __interrupt __far timerhandler()
{
    BIOS_ticks+=counter;
    second_ticks++;
    ticks++;
    if(BIOS_ticks>=0x10000)
    {
        BIOS_ticks=0;
        _chain_intr(prev_int_1c);
    }
    if(second_ticks>=frequency)
    {
        second_flag=1;
        second_ticks=0;
    }
    outp(0x20,0x20);
}

void change_timer()
{
    //swap out the BIOS handler for our own....
    prev_int_1c=_dos_getvect(0x1c);
    _dos_setvect(0x1c,timerhandler);
    //change the clock frequency to 100 per second
    outp(0x43,0x34);
    outp(0x40,(char)(counter%256));
    outp(0x40,(char)(counter/256));
}


void restore_timer()
{
    //restore 18.2 frequency of PIT 0
    outp(0x43,0x34);
    outp(0x40,0);
    outp(0x40,0);
    //restore the BIOS tick handler
    _dos_setvect(0x1c,timerhandler);
}

void draw_number(int *screen, int number)
{
    int sprite[10*5] =
    {    2,5,5,5,2,
	 2,6,2,2,7,
	 6,1,2,4,7,
	 6,1,3,1,6,
	 5,5,7,1,1,
	 7,4,6,1,6,
	 7,4,7,5,7,
	 7,1,1,1,1,
	 7,5,7,5,7,
	 7,5,7,1,7};
    int num[3];
    int i, j, k;

    num[2]=number%10;
    num[1]=(number/10)%10;
    num[0]=(number/100)%10;

    for (i=0; i<3; i++)
        for (j=0; j<5; j++)
	{
	    k=sprite[num[i]*5+j];
	    if (k&4) screen[(i<<2) + XMax*j]=0x00FFFFFF;
	    if (k&2) screen[(i<<2) + 1 + XMax*j]=0x00FFFFFF;
	    if (k&1) screen[(i<<2) + 2 + XMax*j]=0x00FFFFFF;
	}
}

void showfps(int *screen)
{
    framecount++;
    if (second_flag) // une seconde de passee
    {
	fps=framecount;
	second_flag=0; // a pu seconde
	framecount=0;      // a pu frame
    }
    draw_number(screen, fps);
}

/*******************************************************************/
/*                                                                 */
/*                   DRAWING PRIMITIVES                            */
/*                                                                 */
/*******************************************************************/

void hlin_clip(int *screen, int x1, int x2, int y, int c)
{
    int i;

    if ((x2<0) || (x1>=XMax)) return;
    if (x1<0) x1=0;
    if (x2>319) x2=319;

    screen+= (y << 6) + (y << 8) + x1;
    for (i=x1; i<=x2; i++)
	 *screen++=c;
}

