#include <stdio.h>
#include <math.h>
#include "moe.h"
#include "filters.h"

#define nbstars 2000

#define zoff 300	// profondeur
#define xoff 160	// point de fuite X
#define yoff 100	// point de fuite Y

#define inc1 0x202020
#define inc2 0x404040

int *background;
int *background_mask;

int fin=0;

int p1 = 10;
int p2 = 50;

int factor=256;

typedef struct
{
    int x, y, z;
    char taille;
} ETOILE;

typedef struct
{
    ETOILE *star;
    int rx, ry, rz;
} STARFIELD;

STARFIELD stars;

float SIN[360], COS[360];

void affiche_etoiles(int *screen, STARFIELD stars, int fc)
{
    int x,y,z;
    int rx, ry, rz;
    int i, c;
    ETOILE s;
    int *scr;
    float m00, m10, m20, m01, m11, m21, m02, m12, m22;
    int nbs;
    int col;

    if (fc<500)
    {
	nbs=400 + fc * 1600 / 500;
    }
    else nbs = nbstars;
    nbs=2000;
    
    rx=stars.rx;
    ry=stars.ry;
    rz=stars.rz;

    m00 = COS[rz]*COS[ry];
    m10 = SIN[rz]*COS[ry];
    m20 = -SIN[ry];

    m01 = COS[rz]*SIN[ry]*SIN[rx] - SIN[rz]*COS[rx];
    m11 = SIN[rz]*SIN[ry]*SIN[rx] + COS[rx]*COS[rz];
    m21 = SIN[rx]*COS[ry];

    m02 = COS[rz]*SIN[ry]*COS[rx] + SIN[rz]*SIN[rx];
    m12 = SIN[rz]*SIN[ry]*COS[rx] - COS[rz]*SIN[rx];
    m22 = COS[rx]*COS[ry];
    
    for (i=0; i<nbs; ++i)
    {
	s=stars.star[i];
        x=  m00 * s.x
          + m10 * s.y
          + m20 * s.z;

        y=  m01 * s.x
      	  + m11 * s.y
      	  + m21 * s.z;

        z=  m02 * s.x
          + m12 * s.y
          + m22 * s.z;

	x = x*factor>>8;
	y = y*factor>>8;
	z = z*factor>>8;
        z+=zoff;
     	if (z==0) z=1;
    	x=(x << 8) / z + xoff;
    	y=(y << 8) / z + yoff;

    	c= s.taille;
	
    	scr=screen+(y<<6)+(y<<8)+x;
	if ((x>0) && (x<XMax-2) && (y>0) && (y<YMax-2))
	{
	    col = rand()%1;
	    col = col<<3;
	    if (c==0)
	    {
		*scr-=inc1;
	    }
	    else
	    if (c==1)
	    {
		*scr-=inc1;
		*(scr+1)-=inc1;
		*(scr+320)-=inc1;
		*(scr+321)-=inc1;
	    }
	    else
	    if (c==2)
	    {
		*scr-=inc2;
		*(scr-320)-=inc1;
		*(scr-1)-=inc1;
		*(scr+1)-=inc1;
		*(scr+320)-=inc1;
	    }
	    else
	    if (c==3)
	    {
		*scr-=inc2<<col;
		*(scr+1)-=inc2;
		*(scr+320)-=inc2;
		*(scr+321)-=inc2;
		*(scr-320)-=inc1;
		*(scr-319)-=inc1;
		*(scr-1)-=inc1;
		*(scr+2)-=inc1;
		*(scr+319)-=inc1;
		*(scr+322)-=inc1;
		*(scr+640)-=inc1;
		*(scr+641)-=inc1;
	    }
	}
    }
}

void plus_filter(int *dest, int *source, int count);
#pragma aux plus_filter=\
"	shr ecx, 2	"\
"	@loop1:		"\
"	lodsd		"\
"	add [edi], eax	"\
"	add edi, 4	"\
"	loop @loop1	"\
parm [edi] [esi] [ecx] modify [eax esi edi ecx];

void move_stars(STARFIELD stars, int fc, int p1, int p2)
{
    int i;
    int over;
    
    for (i=0; i<nbstars; i++)
    {
	    stars.star[i].z-=10;
	over=0;
	if (stars.star[i].z>zoff)
	{
	    over=1;
	    stars.star[i].z-= 2*zoff;
//	stars.star[i].z=/*(i*zoff/nbstars)*2-zoff;*/(10*i)%(2*zoff)-zoff;
	}
	if (stars.star[i].z<-zoff)
	{
	    over=1;
	    stars.star[i].z+= 2*zoff;
//	stars.star[i].z=/*(i*zoff/nbstars)*2-zoff;*/(10*i)%(2*zoff)-zoff;
	}
	if (over)
	{
	    if (fc<840) {}
	    else
	    {
//		stars.star[i].x=p1*cos(i*3.14/720)+p2*cos(i*3.14/24);
//		stars.star[i].y=p2*sin(i*3.14/24)+p1*sin(i*3.14/720);
//	stars.star[i].x=10*cos(i*3.14/720)+50*cos(i*3.14/24);
//	stars.star[i].y=50*sin(i*3.14/24)+10*sin(i*3.14/720);
	    }
	}
    }
}

void move_angle(STARFIELD *stars, int count)
{
    stars->rx=0;
    /* 6,5 secondes, tout droit avec explosions */
    if (count<7*sec+35)
    {
	stars->ry = 0;
    	factor = 2048- count * (2048-256) / (7*sec+35);
    }
    /* 6,5 secondes, virage a gauche... */
    else if (count<7*sec*2+70)
    {
	if (factor>256) factor-=8;
	stars->ry=45;
    }
    else if (count<7*sec*3+35*3)
    {
	if (stars->ry >-45) stars->ry = 45 - (count-7*sec*3+35*3) * 90 / (3*sec);
    }


//    stars->rx=(stars->rx+1)%360;
/*    if (fc>200) stars->ry=(stars->ry+1)%360;
           else stars->ry=0;
*/    stars->rz-=1; if (stars->rz<0) stars->rz+=360;
}

void change_param(int fc, int *p1, int *p2)
{
    if ((fc%100)==0)
    {
	*p1-=1;
	*p2+=1;
    }
}

void stars_init()
{
    int i, j;
    
    for (i=0; i<360; ++i)
    {
	SIN[i]=sin(i * 3.1415927 / 180);
	COS[i]=cos(i * 3.1415927 / 180);
    }

    stars.star=(ETOILE *)malloc(nbstars*sizeof(ETOILE));
    stars.rx=0;
    stars.ry=0;
    stars.rz=0;

    for (i=0; i<nbstars; i++)
    {
	stars.star[i].x=10*cos(i*3.14/720)+50*cos(i*3.14/24);
	stars.star[i].y=50*sin(i*3.14/24)+10*sin(i*3.14/720);
	stars.star[i].z=/*(i*zoff/nbstars)*2-zoff;*/(10*i)%(2*zoff)-zoff;
	stars.star[i].taille=rand()%4;
    }

    background=(void *)malloc(320*200*4);
    loadraw(background, "PIX1.RAW", 320*200*3);

    background_mask=(void *)malloc(320*200*4);
    loadraw(background_mask, "PIX1M.RAW", 320*200*3);
}

void stars_effect()
{
    int count = 0;
    int save = ticks;
    while (!(inp(0x60)==1) && (count<26*sec))
    {
        count=ticks-save;

	move_angle(&stars, count);
        move_stars(stars, count, p1, p2);
	change_param(count, &p1, &p2);

        memset(screen, 	0xd0	, 	20*320*4);
	memset(screen+20*320,  0xFF, 	160*320*4);
	memset(screen+180*320,  0xd0, 	20*320*4);

	affiche_etoiles(screen, stars, count);
	and_filter(screen, background_mask, 320*200*4);
	plus_filter(screen, background, 320*200*4);

	while (count==ticks);
	MOEflip(screen);
    }
}
