#include "tunnel.h"
#include "bart.h"
#include "tunseq.h"
#include <stdlib.h>
#include <time.h>


extern float tcostable[256],
      tsintable[256];
extern int *map, *map0, *map1, *map2, *map3,*map4,*map5,*map6,*map7,*map8;

int randtable[4096];

int save;

int x,y,_x=0;
int i,i1;
int brayon;
int angle=0,step=0;
BART gen[2],*b[2],temp;
float cs,ss;

void move_bart(BART *b)
{
    if(b->power != 0)
    {
        b->x+=b->xs;
        b->y+=b->ys;
    }

    if(((b->x<(-2*b->radius)) || (b->x>(320+2*b->radius))) && ((b->y<(-2*b->radius)) || (b->y>(200+2*b->radius))))
    {
	b->power = 0;
    }
}

void	initrand()
{
    int i;
    srand(time(NULL));
    for(i=0;i<4096;++i)randtable[i]=rand();
}

int randcount = 0;

int	tRAND()
{
    randcount++;
    if(randcount>=4096)
    randcount = 0;

    return randtable[randcount];
}

void	seq1init()
{
    int i;

    initrand();
    bart_initmap();
    if(!tunnelinit()) return;
    for(i=0;i<2;++i)
    {
        b[i] = (BART *)malloc(N_BART*sizeof(BART));
    
    	for(i1=0;i1<N_BART;++i1)b[i][i1].power=0;
    	
    	gen[i].radius=32;
    	gen[i].r=255;
    	gen[i].v=255;
    	gen[i].b=tRAND()%256;
    }
    save=ticks;
}
void	seq1exit()
{
    bart_freemap();
    tunnelexit();
}

void tunnel(int map_num,int duree)
{
    int tunneldone=0;
    int start;
    int count;

    ticks=save;
    start=ticks;
   switch(map_num)
   {
       case 0 : memcpy(map,map0,64000*4);break;
       case 1 : memcpy(map,map1,64000*4);break;
       case 2 : memcpy(map,map2,64000*4);break;
       case 3 : memcpy(map,map3,64000*4);break;
       case 4 : memcpy(map,map4,64000*4);break;
       case 5 : memcpy(map,map5,64000*4);break;
       case 6 : memcpy(map,map6,64000*4);break;
       case 7 : memcpy(map,map7,64000*4);break;
       case 8 : memcpy(map,map8,64000*4);break;
       default : memcpy(map,map0,64000*4);
   }

    while(!tunneldone && !(inp(0x60)==1))
    {
	_x = 1 -_x;
	
	calc_tunnel();
	interpol();

	cs=tCOS(angle);
	ss=tSIN(angle);
	
	x = ss * brayon;
	y = cs * brayon;

	gen[0].x = x+160;
	gen[0].y = y+100;
	
	gen[1].x = -x+160;
	gen[1].y = -y+100;
	
	for(i1=0;i1<2;++i1)
	{
        	for(i=0;i<4;++i)
        	{
	    	    temp.x=gen[i1].x;
     	    	    temp.y=gen[i1].y;
     	    	    temp.r=tRAND()%256;
	    	    temp.v=tRAND()%256;
	    	    temp.b=tRAND()%256;
	    	    temp.xs=tRAND()%4 - 2; if(!temp.xs)temp.xs=-2;
	    	    temp.ys=tRAND()%4 - 2; if(!temp.ys)temp.ys=-2;
	    	    temp.radius=12;
	    	    temp.power = 1;

	    	    bart_new(b[i1],temp);
        	}
	
		for(i=0;i<N_BART;++i)
		{
	    	    move_bart(&b[i1][i]);
	    	    if(!_x)
		    	b[i1][i].radius--;
	    	    if(b[i1][i].radius<2)b[i1][i].power=0;
		}

		bart_draw(screen,gen[i1]);
		bart_drawall(screen,b[i1]);
	}
	
	count = ticks;
	while (count==ticks);
	MOEflip();	
	brayon = tCOS(angle>>2) * 80;
	angle = count>>1;
	if((count - start) >= duree)tunneldone = 1;
    }
    save=count;

}
